<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE videocollection [
  <!ENTITY ndash "&#8211;">
  <!ENTITY mdash "&#8212;">
]>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:java="http://xml.apache.org/xslt/java"
	xmlns:util="xalan://org.greenstone.gsdl3.util.XSLTUtil"
	xmlns:gslib="http://www.greenstone.org/skinning"
	extension-element-prefixes="java util"
	exclude-result-prefixes="java util">

	<!-- use the 'main' layout -->
	<xsl:include href="layouts/main.xsl"/>

	<!-- set page title -->
	<xsl:template name="pageTitle"><gslib:collectionName/></xsl:template>

	<!-- set page breadcrumbs -->
	<xsl:template name="breadcrumbs"><gslib:siteLink/><gslib:rightArrow/></xsl:template>

	<!-- the page content -->
	<xsl:template match="/page">
  
		<!--Display the description text of the current collection,
		and if some services are available then create a list
		of links for each service within a <ul id="servicelist"> element.-->

    <xsl:variable name="httpPath"> 
      <xsl:value-of select="/page/pageResponse/collection/metadataList/metadata[@name='httpPath']" />
    </xsl:variable>

    <link href="http://fonts.googleapis.com/css?family=Pacifico" type="text/css" rel="stylesheet"></link>
    <link href="http://fonts.googleapis.com/css?family=Rock+Salt" type="text/css" rel="stylesheet"></link>
<!--
    <link href="{$httpPath}/style/?family=Pacifico" type="text/css" rel="stylesheet"></link>
-->

    <link rel="stylesheet" href="{$httpPath}/style/style.css" ></link>
    <link rel="stylesheet" href="{$httpPath}/style/about-sub.css" ></link>

    <style>
      p.about { text-align: justify; }
      h2 { /* line-height: 135%; */ }
      h3 { margin-top: 4pt; margin-bottom: 7pt; line-height: 135%; }

        a.mashup {text-decoration: none; } 
	a.mashup:link    {color:#000080;}  /* unvisited link */
	a.mashup:visited {color:#303080;}  /* visited link */
	a.mashup:hover   {color:#000040;}  /* mouse over link */
	a.mashup:active  {color:#0000a0;}

    </style>


    <script src="{$httpPath}/script2/browser-detect.js" type="text/javascript">
	/* space filler needed */
    </script>



<div style="width: 800px; margin-left: auto; margin-right: auto;">

  <xsl:if test="$interface_name='dlfm'">
    <style>
      .popbanner {
        background-color: #DEEDF7;
	color: #000;
      } 
    </style>
  </xsl:if>

  
  <div class="popbanner">
    <div class="poptitle">
      Popup Videos Respooled
    </div>
    <div class="popbannersubtext">
      Brought to you by VHHHHH1(*)
    </div>
    <div style="height: 10pt;"><hr /><xsl:comment>forced gap</xsl:comment></div>
    <div class="popbannernote">
      (*) <i>not affiliated to any music TV stations with fewer H's</i>
    </div>
  </div>


<xsl:choose>
  <xsl:when test="$interface_name='dlfm'">
    <p class="about">
      Welcome to the Digitial Library for Musicology version of the
      <i>Popup Videos Respooled</i> website.  This is a project that
      repurposes the <a
      href="/greenstone3/respooled-library/collection/popup-video-respooled/page/about">original
      Respooled project</a> (designed for a bit of fun), and recasts
      it with an interface and functionality more suitable for
      supporting musicological study.
    </p>
  </xsl:when>
  <xsl:otherwise>
    <p class="about">
      Welcome to <i>Popup Videos Respooled</i>, a project that rekindles the
      ideas present in the popular music video TV show <i>Pop Up Videos</i>,
      a Music TV format devised in the late 1990s that embellishes the shown
      content with <i>info nuggets</i> that popup as bubbles and then
      disappear, as a music video plays.  Through this website we have
      updated and extended the concept, using the open source <a
      href="http://www.greenstone.org/greenstone3">Greenstone 3 Digital
      Library Software</a> system as a way to organize the set of videos
      contained in the site.  The popup information is collated and
      displayed as metadata.  We have also introduced a gamification element
      to the site, where users can play along with a song using a range of
      virtual musical instruments: piano, drum-kit and guitar.
    </p>
  </xsl:otherwise>
</xsl:choose>

<p class="about">
  Use the search box above to search for content in the digital library, or else
  click on the Titles, Artists, or Albums tabs to browser the collection
</p>

<xsl:if test="$interface_name='respooled'">
  <p class="about">
    You might also be interested in the <a
    href="/greenstone3/dlfm-library/collection/popup-video-respooled/page/about">alternative
    interface</a> to this content, developed for
    supporting musicological study.
  </p>
</xsl:if>


<xsl:choose>
  <xsl:when test="/page/pageRequest/userInformation/@username">
      <p class="about">
	To incorpoate new videos into the collection, you need to
	have the <a href="/greenstone3/Popup_Videos_Respooled.user.js">RespoolMe!</a> User Script installed in your browser
      </p>
	
  </xsl:when>
</xsl:choose>
  
</div>


	</xsl:template>


</xsl:stylesheet>  

